## libqes 0.1.21

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
PROJECT(libqes C)

# Append cmake-modules to module path
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules")


IF (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/version")
	FILE(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/version" LIBQES_VERSION)
ELSE()
	# git describe as versioning
	EXECUTE_PROCESS(COMMAND git describe
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			OUTPUT_VARIABLE LIBQES_VERSION
			OUTPUT_STRIP_TRAILING_WHITESPACE)
ENDIF()

#############################
## Setup CMAKE Environment ##
#############################

# Set this before you include libqes as a CMake subproject, so that we know not
# to add cmake to the install rule
IF (LIBQES_AS_SUBMODULE)
    SET(LIBQES_DONT_INSTALL True)
ELSE()
    SET(LIBQES_DONT_INSTALL False)
ENDIF()

OPTION(NO_OPENMP "Disable OpenMP" False)
OPTION(NO_ZLIB "Disable zlib" False)
# Shortcut to enable dev compile options
OPTION(DEV "Enable developer warnings")
IF (DEV)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fsanitize=address -fsanitize=leak -fsanitize=undefined")
    SET(CMAKE_BUILD_TYPE Coverage)
ENDIF()

IF (NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE Release)
ENDIF()

MESSAGE(STATUS "${CMAKE_BUILD_TYPE} build of ${PROJECT_NAME} version: ${LIBQES_VERSION}")

# Set output directories
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

# Include coverage module IFF out build type is Coverage to avoid bailing out
# with unmet dependencies on Release builds, i.e. other peoples' computers
IF (CMAKE_BUILD_TYPE STREQUAL "Coverage")
    INCLUDE(CodeCoverage)
ENDIF()

# Testing
ENABLE_TESTING()

# Packaging
SET(CPACK_GENERATOR "TGZ;TBZ2")
INCLUDE(CPack)

###############################
## Find Packages and Headers ##
###############################

# Header/symbols
INCLUDE(CheckSymbolExists)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckLibraryExists)
INCLUDE(CheckIncludeFiles)

CHECK_SYMBOL_EXISTS(vasprintf stdio.h VASPRINTF_FOUND)
CHECK_SYMBOL_EXISTS(asprintf stdio.h ASPRINTF_FOUND)
CHECK_SYMBOL_EXISTS(getline stdio.h GETLINE_FOUND)
CHECK_SYMBOL_EXISTS(strndup string.h STRNDUP_FOUND)

IF (NOT ${NO_ZLIB})
    FIND_PACKAGE(ZLIB 1.2.1 REQUIRED)
    CHECK_LIBRARY_EXISTS(${ZLIB_LIBRARIES} gzbuffer "" GZBUFFER_FOUND)
ELSE()
    SET(ZLIB_FOUND FALSE)
    SET(GZBUFFER_FOUND FALSE)
    SET(ZLIB_C_FLAGS "")
    SET(ZLIB_LIBRARIES "")
    SET(ZLIB_INCLUDE_DIRS "")
    MESSAGE(STATUS "Building without zlib")
ENDIF()

IF (NOT ${NO_OPENMP})
    FIND_PACKAGE(OpenMP)
ELSE()
    SET(OPENMP_FOUND FALSE)
    SET(OpenMP_C_FLAGS "")
    MESSAGE(STATUS "Building without OpenMP")
ENDIF()

# Set dependency flags appropriately
SET(LIBQES_DEPENDS_LIBS
    ${LIBQES_DEPENDS_LIBS}
    ${ZLIB_LIBRARIES})
SET(LIBQES_DEPENDS_INCLUDE_DIRS
    ${LIBQES_DEPENDS_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS})
SET(LIBQES_DEPENDS_CFLAGS
    ${LIBQES_DEPENDS_CFLAGS}
    ${ZLIB_CFLAGS}
    ${OpenMP_C_FLAGS})

##########################
## Set Compiler Options ##
##########################

# Set GCC-specific options
IF (CMAKE_COMPILER_IS_GNUCC)
    SET(WEXTRA_FLAGS "${WEXTRA_FLAGS} -Woverride-init -Wnormalized=id -Wlogical-op")
    EXECUTE_PROCESS(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
    IF (${GCC_VERSION} VERSION_GREATER 4.9 OR ${GCC_VERSION} VERSION_EQUAL 4.9)
        SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fdiagnostics-color=always")
    ENDIF()
ENDIF()

# Set CFLAGS
SET(WEXTRA_FLAGS "${WEXTRA_FLAGS} -Wstack-protector -Wfloat-equal")
SET(WEXTRA_FLAGS "${WEXTRA_FLAGS} -Wundef -Wpointer-arith -Wstrict-prototypes")
SET(WEXTRA_FLAGS "${WEXTRA_FLAGS} -Wmissing-prototypes -Wwrite-strings -Wredundant-decls")
SET(WEXTRA_FLAGS "${WEXTRA_FLAGS} -Wchar-subscripts -Wcomment -Wformat=2 -Wwrite-strings")
SET(WEXTRA_FLAGS "${WEXTRA_FLAGS} -Wmissing-declarations -Wredundant-decls -Wnested-externs")
SET(WEXTRA_FLAGS "${WEXTRA_FLAGS} -Wbad-function-cast -Wswitch-enum -Winit-self")
SET(WEXTRA_FLAGS "${WEXTRA_FLAGS} -Wmissing-field-initializers -Wdeclaration-after-statement")
SET(WEXTRA_FLAGS "${WEXTRA_FLAGS} -Wold-style-definition -Waddress -Wmissing-noreturn ")
SET(WEXTRA_FLAGS "${WEXTRA_FLAGS} -Wstrict-overflow=1 -Wextra -Warray-bounds -Wall")

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${LIBQES_DEPENDS_CFLAGS} -std=gnu99 ${WEXTRA_FLAGS}")

SET(CMAKE_C_FLAGS_DEBUG "-ggdb")
SET(CMAKE_C_FLAGS_RELEASE "-O3")

# Set include dirs
INCLUDE_DIRECTORIES(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/src
    ${CMAKE_CURRENT_SOURCE_DIR}/test
    ${CMAKE_CURRENT_SOURCE_DIR}/test/tinytest
    ${LIBQES_DEPENDS_INCLUDE_DIRS}
    )

# Set link dirs
LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/lib)

# Traverse to library source and tests
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(test)

=== src/CMakeLists.txt ===
file(GLOB LIBQES_SOURCES qes_*.c)

# Targets
ADD_LIBRARY(qes_static STATIC ${LIBQES_SOURCES})
SET_TARGET_PROPERTIES(qes_static PROPERTIES OUTPUT_NAME qes)
TARGET_LINK_LIBRARIES(qes_static ${LIBQES_DEPENDS_LIBS})
ADD_LIBRARY(qes SHARED ${LIBQES_SOURCES})
SET_TARGET_PROPERTIES(qes PROPERTIES SONAME_VERSION 0 VERSION 0)
TARGET_LINK_LIBRARIES(qes ${LIBQES_DEPENDS_LIBS})

CONFIGURE_FILE(qes_config.h.in ${CMAKE_BINARY_DIR}/qes_config.h)
FILE(GLOB LIBQES_HEADERS ${CMAKE_SOURCE_DIR}/src/*.h ${CMAKE_BINARY_DIR}/qes_config.h)

IF (NOT LIBQES_DONT_INSTALL)
	INSTALL(FILES ${LIBQES_HEADERS} DESTINATION "include")
	INSTALL(TARGETS qes qes_static DESTINATION "lib")
ENDIF()

=== test/CMakeLists.txt ===
## Compile tests, & set up coverage
SET(COMMON_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/helpers.c)
FILE(GLOB TEST_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/test*.c)
SET(TEST_SRCS ${COMMON_SRCS} ${TEST_SRCS} ${CMAKE_CURRENT_SOURCE_DIR}/tinytest/tinytest.c)
ADD_EXECUTABLE(test_libqes ${TEST_SRCS})
TARGET_LINK_LIBRARIES(test_libqes qes ${LIBQES_DEPENDS_LIBS})
IF (CMAKE_BUILD_TYPE STREQUAL "Coverage")
    SETUP_TARGET_FOR_COVERAGE(coverage test_libqes coverage src)
ENDIF()
ADD_TEST(NAME run_test_libqes
         COMMAND ${CMAKE_BINARY_DIR}/bin/test_libqes ${CMAKE_BINARY_DIR})

# Demos
ADD_EXECUTABLE(log_demo ${CMAKE_CURRENT_SOURCE_DIR}/logdemo.c)
TARGET_LINK_LIBRARIES(log_demo qes ${LIBQES_DEPENDS_LIBS})
ADD_TEST(NAME run_log_demo
         COMMAND ${CMAKE_BINARY_DIR}/bin/log_demo)

# Benchmarking:
ADD_EXECUTABLE(bench_libqes ${CMAKE_CURRENT_SOURCE_DIR}/benchmarks.c ${COMMON_SRCS})
TARGET_LINK_LIBRARIES(bench_libqes qes ${LIBQES_DEPENDS_LIBS})
ADD_TEST(NAME run_bench_libqes
         COMMAND ${CMAKE_BINARY_DIR}/bin/bench_libqes
         ${CMAKE_BINARY_DIR}/data/test.fastq
         50
         qes_seqfile_write
         kseq_parse_fq
         gnu_getline
         qes_seqfile_parse_fq
         qes_file_readline_realloc)

# Copy test files over to bin dir
ADD_CUSTOM_COMMAND(TARGET test_libqes
                   COMMAND ${CMAKE_COMMAND} -E copy_directory
		    ${CMAKE_CURRENT_SOURCE_DIR}/data
		    ${CMAKE_BINARY_DIR}/data)

=== debian/changelog ===
libqes (0.1.21-1) unstable; urgency=medium

  * New upstream release (Closes: #808710)

 -- Kevin Murray <spam@kdmurray.id.au>  Tue, 22 Dec 2015 10:59:59 +1100

libqes (0.1.20-1) unstable; urgency=medium

  * Initial release (Closes: #805153)

 -- Kevin Murray <spam@kdmurray.id.au>  Wed, 21 Oct 2015 16:20:26 +1100

=== debian/control ===
Source: libqes
Priority: optional
Maintainer: Debian Med Packaging <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Kevin Murray <spam@kdmurray.id.au>
Build-Depends: debhelper (>= 9),
               cmake,
               zlib1g-dev,
               dh-exec,
Standards-Version: 3.9.6
Section: libs
Homepage: https://github.com/kdmurray91/libqes
Vcs-Git: git://anonscm.debian.org/debian-med/libqes.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/libqes.git

Package: libqes-dev
Section: libdevel
Architecture: any
Depends: libqes0 (= ${binary:Version}),
        ${misc:Depends},
        zlib1g-dev,
Description: DNA sequence parsing library -- development
 A small C library, with a bioinformatic focus. Optimised for speed and a clean
 API. Handles sequence parsing and miscellaneous manipulation of DNA sequences.
 .
 These are the development headers required to use libqes in your own
 applications.

Package: libqes0
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: DNA sequence parsing library
 A small C library, with a bioinformatic focus. Optimised for speed and a clean
 API. Handles sequence parsing and miscellaneous manipulation of DNA sequences.
 .
 This package is the shared library which programs using libqes should link to.
 Developers will want libqes-dev installed to use libqes in developing their
 applications.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEBPKGNAME     := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')

%:
	dh $@ --buildsystem=cmake --parallel

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/libqes_$1.tar.gz/" \
  https://github.com/kdmurray91/libqes/tags .*/v?(\d\S*)\.tar\.gz

## libqes 0.2.7

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,22 @@
 file(GLOB LIBQES_SOURCES qes_*.c)
 
 # Targets
-ADD_LIBRARY(qes_static STATIC ${LIBQES_SOURCES})
+if(LIBQES_DONT_INSTALL)
+    ADD_LIBRARY(qes_static STATIC EXCLUDE_FROM_ALL ${LIBQES_SOURCES})
+    ADD_LIBRARY(qes SHARED EXCLUDE_FROM_ALL ${LIBQES_SOURCES})
+else()
+    ADD_LIBRARY(qes_static STATIC ${LIBQES_SOURCES})
+    ADD_LIBRARY(qes SHARED ${LIBQES_SOURCES})
+endif()
+
+
 SET_TARGET_PROPERTIES(qes_static PROPERTIES OUTPUT_NAME qes)
 TARGET_LINK_LIBRARIES(qes_static ${LIBQES_DEPENDS_LIBS})
-ADD_LIBRARY(qes SHARED ${LIBQES_SOURCES})
+target_include_directories(qes_static PUBLIC ${LIBQES_DEPENDS_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR})
+
 SET_TARGET_PROPERTIES(qes PROPERTIES SONAME_VERSION 0 VERSION 0)
 TARGET_LINK_LIBRARIES(qes ${LIBQES_DEPENDS_LIBS})
+target_include_directories(qes PUBLIC ${LIBQES_DEPENDS_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR})
 
 CONFIGURE_FILE(qes_config.h.in ${CMAKE_BINARY_DIR}/qes_config.h)
 FILE(GLOB LIBQES_HEADERS ${CMAKE_SOURCE_DIR}/src/*.h ${CMAKE_BINARY_DIR}/qes_config.h)

=== debian/changelog ===
libqes (0.2.7-1) unstable; urgency=medium

  * New upstream release (fixes major parsing bug)
  * Update standards version to 3.9.8
  * Update uploader email
  * Hardening+all to pull in bindnow hardening

 -- Kevin Murray <kdmfoss@gmail.com>  Thu, 01 Dec 2016 12:19:16 +1100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: libqes
 Priority: optional
 Maintainer: Debian Med Packaging <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Kevin Murray <spam@kdmurray.id.au>
+Uploaders: Kevin Murray <kdmfoss@gmail.com>
 Build-Depends: debhelper (>= 9),
                cmake,
                zlib1g-dev,
                dh-exec,
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Section: libs
 Homepage: https://github.com/kdmurray91/libqes
-Vcs-Git: git://anonscm.debian.org/debian-med/libqes.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/libqes.git
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/libqes.git
 
 Package: libqes-dev

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+export DEB_BUILD_MAINT_OPTIONS += hardening=+all
+
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk

## libqes 0.2.8

=== debian/changelog ===
libqes (0.2.8-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4
  * debhelper 11
  * d/rules: do not parse d/changelog

 -- Andreas Tille <tille@debian.org>  Sat, 28 Apr 2018 22:41:33 +0200

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,23 @@
 Source: libqes
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Kevin Murray <kdmfoss@gmail.com>
+Section: libs
 Priority: optional
-Maintainer: Debian Med Packaging <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Kevin Murray <kdmfoss@gmail.com>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 11~),
                cmake,
                zlib1g-dev,
-               dh-exec,
-Standards-Version: 3.9.8
-Section: libs
+               dh-exec
+Standards-Version: 4.1.4
+Vcs-Browser: https://salsa.debian.org/med-team/libqes
+Vcs-Git: https://salsa.debian.org/med-team/libqes.git
 Homepage: https://github.com/kdmurray91/libqes
-Vcs-Git: https://anonscm.debian.org/git/debian-med/libqes.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/libqes.git
 
 Package: libqes-dev
+Architecture: any
 Section: libdevel
-Architecture: any
 Depends: libqes0 (= ${binary:Version}),
-        ${misc:Depends},
-        zlib1g-dev,
+         ${misc:Depends},
+         zlib1g-dev
 Description: DNA sequence parsing library -- development
  A small C library, with a bioinformatic focus. Optimised for speed and a clean
  API. Handles sequence parsing and miscellaneous manipulation of DNA sequences.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS += hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake

## libqes 0.2.8%2Bds

=== debian/rules ===
--- 
+++ 
@@ -6,3 +6,12 @@
 
 %:
 	dh $@ --buildsystem=cmake
+
+override_dh_install:
+	dh_install
+	d-shlibmove --commit \
+		    --multiarch \
+		    --devunversioned \
+		    --exclude-la \
+		    --movedev debian/tmp/usr/include usr \
+		    debian/tmp/usr/lib/*.so

## libqes 0.2.8+ds

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
PROJECT(libqes C)

if (NOT DEFINED LIBQES_IS_SUBPROJECT)
  if ("^${CMAKE_SOURCE_DIR}$" STREQUAL "^${PROJECT_SOURCE_DIR}$")
    set (LIBQES_IS_SUBPROJECT FALSE)
  else ()
    set (LIBQES_IS_SUBPROJECT TRUE)
    message(STATUS "Detected that LIBQES is used a subproject.")
  endif ()
endif ()


# Append cmake-modules to module path
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
    "${PROJECT_SOURCE_DIR}/cmake-modules")


IF (NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE Release)
ENDIF()


IF (NOT LIBQES_IS_SUBPROJECT)
    IF (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/version")
        FILE(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/version" LIBQES_VERSION)
    ELSE()
        # git describe as versioning
        EXECUTE_PROCESS(COMMAND git describe
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                OUTPUT_VARIABLE LIBQES_VERSION
                OUTPUT_STRIP_TRAILING_WHITESPACE)
    ENDIF()
    MESSAGE(STATUS "${CMAKE_BUILD_TYPE} build of ${PROJECT_NAME} version: ${LIBQES_VERSION}")
ELSE()
    SET(LIBQES_VERSION "")
ENDIF()


#############################
## Setup CMAKE Environment ##
#############################

# Set this before you include libqes as a CMake subproject, so that we know not
# to add cmake to the install rule
IF (LIBQES_IS_SUBPROJECT)
    IF(NOT DEFINED LIBQES_DONT_INSTALL)
        SET(LIBQES_DONT_INSTALL True)
    ELSE()
        SET(LIBQES_DONT_INSTALL False)
    ENDIF()
ENDIF()

OPTION(NO_OPENMP "Disable OpenMP" False)
OPTION(NO_ZLIB "Disable zlib" False)
# Shortcut to enable dev compile options
OPTION(DEV "Enable developer warnings")
IF (DEV)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fsanitize=address -fsanitize=leak -fsanitize=undefined")
    SET(CMAKE_BUILD_TYPE Coverage)
ENDIF()

# Set output directories
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

# Include coverage module IFF out build type is Coverage to avoid bailing out
# with unmet dependencies on Release builds, i.e. other peoples' computers
IF (CMAKE_BUILD_TYPE STREQUAL "Coverage")
    INCLUDE(CodeCoverage)
ENDIF()

# Testing
ENABLE_TESTING()

# Packaging
SET(CPACK_GENERATOR "TGZ;TBZ2")
INCLUDE(CPack)

##########################
## Set Compiler Options ##
##########################


SET(WARN_FLAGS "${WARN_FLAGS} -Wall -Wextra -pedantic")

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -D_GNU_SOURCE ${WARN_FLAGS}")

SET(CMAKE_C_FLAGS_DEBUG "-ggdb")
SET(CMAKE_C_FLAGS_RELEASE "-O3")


###############################
## Find Packages and Headers ##
###############################

# Header/symbols
INCLUDE(CheckSymbolExists)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckLibraryExists)
INCLUDE(CheckIncludeFiles)

CHECK_SYMBOL_EXISTS(vasprintf stdio.h VASPRINTF_FOUND)
CHECK_SYMBOL_EXISTS(asprintf stdio.h ASPRINTF_FOUND)
CHECK_SYMBOL_EXISTS(getline stdio.h GETLINE_FOUND)
CHECK_SYMBOL_EXISTS(strndup string.h STRNDUP_FOUND)

IF (NOT ${NO_ZLIB})
    FIND_PACKAGE(ZLIB 1.2.5 REQUIRED)
    CHECK_LIBRARY_EXISTS(${ZLIB_LIBRARIES} gzbuffer "" GZBUFFER_FOUND)
ELSE()
    SET(ZLIB_FOUND FALSE)
    SET(GZBUFFER_FOUND FALSE)
    SET(ZLIB_C_FLAGS "")
    SET(ZLIB_LIBRARIES "")
    SET(ZLIB_INCLUDE_DIRS "")
    MESSAGE(STATUS "Building without zlib")
ENDIF()

IF (NOT ${NO_OPENMP})
    FIND_PACKAGE(OpenMP)
ELSE()
    SET(OPENMP_FOUND FALSE)
    SET(OpenMP_C_FLAGS "")
    MESSAGE(STATUS "Building without OpenMP")
ENDIF()

# Set dependency flags appropriately
SET(LIBQES_DEPENDS_LIBS
    ${LIBQES_DEPENDS_LIBS}
    ${ZLIB_LIBRARIES})
SET(LIBQES_DEPENDS_INCLUDE_DIRS
    ${LIBQES_DEPENDS_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS})
SET(LIBQES_DEPENDS_CFLAGS
    ${LIBQES_DEPENDS_CFLAGS}
    ${ZLIB_CFLAGS}
    ${OpenMP_C_FLAGS})

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${LIBQES_DEPENDS_CFLAGS}")


#####################
## Set CMake Paths ##
#####################

# Set include dirs
INCLUDE_DIRECTORIES(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/src
    ${CMAKE_CURRENT_SOURCE_DIR}/test
    ${CMAKE_CURRENT_SOURCE_DIR}/test/tinytest
    ${LIBQES_DEPENDS_INCLUDE_DIRS}
    )

# Set link dirs
LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/lib)

# Traverse to library source and tests
ADD_SUBDIRECTORY(src)
if (NOT LIBQES_IS_SUBPROJECT)
    ADD_SUBDIRECTORY(test)
endif()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,15 @@
 ENDIF()
 ADD_TEST(NAME run_test_libqes
          COMMAND ${CMAKE_BINARY_DIR}/bin/test_libqes ${CMAKE_BINARY_DIR})
+
+ADD_EXECUTABLE(qes_seqcat ${CMAKE_CURRENT_SOURCE_DIR}/qes_seqcat.c)
+TARGET_LINK_LIBRARIES(qes_seqcat qes ${LIBQES_DEPENDS_LIBS})
+
+ADD_EXECUTABLE(qes_seqprint ${CMAKE_CURRENT_SOURCE_DIR}/qes_seqprint.c)
+TARGET_LINK_LIBRARIES(qes_seqprint qes ${LIBQES_DEPENDS_LIBS})
+
+ADD_EXECUTABLE(kseqcat ${CMAKE_CURRENT_SOURCE_DIR}/kseqcat.c)
+TARGET_LINK_LIBRARIES(kseqcat qes ${LIBQES_DEPENDS_LIBS})
 
 # Demos
 ADD_EXECUTABLE(log_demo ${CMAKE_CURRENT_SOURCE_DIR}/logdemo.c)

=== debian/changelog ===
libqes (0.2.8+ds-2) unstable; urgency=medium

  * Team upload.
  * cmake-4.patch: new: bump minimum cmake to 3.10. (Closes: #1113190)
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/watch: bump to watch file version 5.

 -- Étienne Mollier <emollier@debian.org>  Thu, 02 Oct 2025 22:13:16 +0200

libqes (0.2.8+ds-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * Standards-Version: 4.5.1 (routine-update)
  * watch file standard 4 (routine-update)

  [ Shayan Doust ]
  * Repack to exclude crc.* (Closes: #965238)
  * New upstream version 0.2.8+ds
  * Mangle version (ds) due to repack

 -- Shayan Doust <hello@shayandoust.me>  Wed, 03 Feb 2021 19:16:19 +0000

libqes (0.2.8-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Use d-shlibs

 -- Andreas Tille <tille@debian.org>  Fri, 30 Oct 2020 14:06:07 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: libqes
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Kevin Murray <kdmfoss@gmail.com>
-Section: libs
+Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                zlib1g-dev,
-               dh-exec
-Standards-Version: 4.1.4
+               d-shlibs
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/libqes
 Vcs-Git: https://salsa.debian.org/med-team/libqes.git
 Homepage: https://github.com/kdmurray91/libqes
@@ -27,6 +27,7 @@
 
 Package: libqes0
 Architecture: any
+Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: DNA sequence parsing library

=== debian/watch ===
Version: 5

Source: https://github.com/kdmurray91/libqes/tags
Matching-Pattern: .*/v?(\d\S*)\.tar\.gz
Compression: xz
Dversionmangle: s/\.ds//
Filenamemangle: s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/libqes_$1.tar.gz/
Repack: yes
Repacksuffix: +ds
